JUCE: ComboBox Class Reference

JUCE

Classes | Public Types | Public Member Functions | Public Attributes | List of all members
ComboBox Class Reference
juce_gui_basics » widgets

A component that lets the user choose from a drop-down list of choices. More...

`#include <juce_ComboBox.h>`

Inheritance diagram for ComboBox:

## Classes
class | Listener
| A class for receiving events from a ComboBox. More...
struct | LookAndFeelMethods
| This abstract base class is implemented by LookAndFeel classes to provide ComboBox functionality. More...

## Public Types
enum | ColourIds { backgroundColourId = 0x1000b00 , textColourId = 0x1000a00 , outlineColourId = 0x1000c00 , buttonColourId = 0x1000d00 , arrowColourId = 0x1000e00 , focusedOutlineColourId = 0x1000f00 }
| A set of colour IDs to use to change the colour of various aspects of the combo box. More...
Public Types inherited from Component
enum class | FocusContainerType { none , focusContainer , keyboardFocusContainer }
| A focus container type that can be passed to setFocusContainerType(). More...
enum | FocusChangeType { focusChangedByMouseClick , focusChangedByTabKey , focusChangedDirectly }
| Enumeration used by the focusGained() and focusLost() methods. More...

## Public Member Functions
| ComboBox (const String &componentName={})
| Creates a combo-box. More...
| ~ComboBox () override
| Destructor. More...
void | setEditableText (bool isEditable)
| Sets whether the text in the combo-box is editable. More...
bool | isTextEditable () const noexcept
| Returns true if the text is directly editable. More...
void | setJustificationType (Justification justification)
| Sets the style of justification to be used for positioning the text. More...
Justification | getJustificationType () const noexcept
| Returns the current justification for the text box. More...
void | addItem (const String &newItemText, int newItemId)
| Adds an item to be shown in the drop-down list. More...
void | addItemList (const StringArray &items, int firstItemIdOffset)
| Adds an array of items to the drop-down list. More...
void | addSeparator ()
| Adds a separator line to the drop-down list. More...
void | addSectionHeading (const String &headingName)
| Adds a heading to the drop-down list, so that you can group the items into different sections. More...
void | setItemEnabled (int itemId, bool shouldBeEnabled)
| This allows items in the drop-down list to be selectively disabled. More...
bool | isItemEnabled (int itemId) const noexcept
| Returns true if the given item is enabled. More...
void | changeItemText (int itemId, const String &newText)
| Changes the text for an existing item. More...
void | clear (NotificationType notification=sendNotificationAsync)
| Removes all the items from the drop-down list. More...
int | getNumItems () const noexcept
| Returns the number of items that have been added to the list. More...
String | getItemText (int index) const
| Returns the text for one of the items in the list. More...
int | getItemId (int index) const noexcept
| Returns the ID for one of the items in the list. More...
int | indexOfItemId (int itemId) const noexcept
| Returns the index in the list of a particular item ID. More...
int | getSelectedId () const noexcept
| Returns the ID of the item that's currently shown in the box. More...
Value & | getSelectedIdAsValue ()
| Returns a Value object that can be used to get or set the selected item's ID. More...
void | setSelectedId (int newItemId, NotificationType notification=sendNotificationAsync)
| Sets one of the items to be the current selection. More...
int | getSelectedItemIndex () const
| Returns the index of the item that's currently shown in the box. More...
void | setSelectedItemIndex (int newItemIndex, NotificationType notification=sendNotificationAsync)
| Sets one of the items to be the current selection. More...
String | getText () const
| Returns the text that is currently shown in the combo-box's text field. More...
void | setText (const String &newText, NotificationType notification=sendNotificationAsync)
| Sets the contents of the combo-box's text field. More...
void | showEditor ()
| Programmatically opens the text editor to allow the user to edit the current item. More...
virtual void | showPopup ()
| Pops up the combo box's list. More...
void | hidePopup ()
| Hides the combo box's popup list, if it's currently visible. More...
bool | isPopupActive () const noexcept
| Returns true if the popup menu is currently being shown. More...
PopupMenu * | getRootMenu () noexcept
| Returns the PopupMenu object associated with the ComboBox. More...
const PopupMenu * | getRootMenu () const noexcept
| Returns the PopupMenu object associated with the ComboBox. More...
void | addListener (Listener *listener)
| Registers a listener that will be called when the box's content changes. More...
void | removeListener (Listener *listener)
| Deregisters a previously-registered listener. More...
void | setTextWhenNothingSelected (const String &newMessage)
| Sets a message to display when there is no item currently selected. More...
String | getTextWhenNothingSelected () const
| Returns the text that is shown when no item is selected. More...
void | setTextWhenNoChoicesAvailable (const String &newMessage)
| Sets the message to show when there are no items in the list, and the user clicks on the drop-down box. More...
String | getTextWhenNoChoicesAvailable () const
| Returns the text shown when no items have been added to the list. More...
void | setTooltip (const String &newTooltip) override
| Gives the ComboBox a tooltip. More...
void | setScrollWheelEnabled (bool enabled) noexcept
| This can be used to allow the scroll-wheel to nudge the chosen item. More...
void | enablementChanged () override
void | colourChanged () override
void | focusGained (Component::FocusChangeType) override
void | focusLost (Component::FocusChangeType) override
void | handleAsyncUpdate () override
String | getTooltip () override
void | mouseDown (const MouseEvent &) override
void | mouseDrag (const MouseEvent &) override
void | mouseUp (const MouseEvent &) override
void | mouseWheelMove (const MouseEvent &, const MouseWheelDetails &) override
void | lookAndFeelChanged () override
void | paint (Graphics &) override
void | resized () override
bool | keyStateChanged (bool) override
bool | keyPressed (const KeyPress &) override
void | valueChanged (Value &) override
void | parentHierarchyChanged () override
Public Member Functions inherited from Component
| Component () noexcept
| Creates a component. More...
| ~Component () override
| Destructor. More...
| Component (const String &componentName) noexcept
| Creates a component, setting its name at the same time. More...
String | getName () const noexcept
| Returns the name of this component. More...
virtual void | setName (const String &newName)
| Sets the name of this component. More...
String | getComponentID () const noexcept
| Returns the ID string that was set by setComponentID(). More...
void | setComponentID (const String &newID)
| Sets the component's ID string. More...
virtual void | setVisible (bool shouldBeVisible)
| Makes the component visible or invisible. More...
bool | isVisible () const noexcept
| Tests whether the component is visible or not. More...
virtual void | visibilityChanged ()
| Called when this component's visibility changes. More...
bool | isShowing () const
| Tests whether this component and all its parents are visible. More...
virtual void | addToDesktop (int windowStyleFlags, void *nativeWindowToAttachTo=nullptr)
| Makes this component appear as a window on the desktop. More...
void | removeFromDesktop ()
| If the component is currently showing on the desktop, this will hide it. More...
bool | isOnDesktop () const noexcept
| Returns true if this component is currently showing on the desktop. More...
ComponentPeer * | getPeer () const
| Returns the heavyweight window that contains this component. More...
virtual void | userTriedToCloseWindow ()
| For components on the desktop, this is called if the system wants to close the window. More...
virtual void | minimisationStateChanged (bool isNowMinimised)
| Called for a desktop component which has just been minimised or un-minimised. More...
virtual float | getDesktopScaleFactor () const
| Returns the default scale factor to use for this component when it is placed on the desktop. More...
void | toFront (bool shouldAlsoGainKeyboardFocus)
| Brings the component to the front of its siblings. More...
void | toBack ()
| Changes this component's z-order to be at the back of all its siblings. More...
void | toBehind (Component *other)
| Changes this component's z-order so that it's just behind another component. More...
void | setAlwaysOnTop (bool shouldStayOnTop)
| Sets whether the component should always be kept at the front of its siblings. More...
bool | isAlwaysOnTop () const noexcept
| Returns true if this component is set to always stay in front of its siblings. More...
int | getX () const noexcept
| Returns the x coordinate of the component's left edge. More...
int | getY () const noexcept
| Returns the y coordinate of the top of this component. More...
int | getWidth () const noexcept
| Returns the component's width in pixels. More...
int | getHeight () const noexcept
| Returns the component's height in pixels. More...
int | getRight () const noexcept
| Returns the x coordinate of the component's right-hand edge. More...
Point< int > | getPosition () const noexcept
| Returns the component's top-left position as a Point. More...
int | getBottom () const noexcept
| Returns the y coordinate of the bottom edge of this component. More...
Rectangle< int > | getBounds () const noexcept
| Returns this component's bounding box. More...
Rectangle< int > | getLocalBounds () const noexcept
| Returns the component's bounds, relative to its own origin. More...
Rectangle< int > | getBoundsInParent () const noexcept
| Returns the area of this component's parent which this component covers. More...
int | getScreenX () const
| Returns this component's x coordinate relative the screen's top-left origin. More...
int | getScreenY () const
| Returns this component's y coordinate relative the screen's top-left origin. More...
Point< int > | getScreenPosition () const
| Returns the position of this component's top-left corner relative to the screen's top-left. More...
Rectangle< int > | getScreenBounds () const
| Returns the bounds of this component, relative to the screen's top-left. More...
Point< int > | getLocalPoint (const Component *sourceComponent, Point< int > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Point< float > | getLocalPoint (const Component *sourceComponent, Point< float > pointRelativeToSourceComponent) const
| Converts a point to be relative to this component's coordinate space. More...
Rectangle< int > | getLocalArea (const Component *sourceComponent, Rectangle< int > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Rectangle< float > | getLocalArea (const Component *sourceComponent, Rectangle< float > areaRelativeToSourceComponent) const
| Converts a rectangle to be relative to this component's coordinate space. More...
Point< int > | localPointToGlobal (Point< int > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Point< float > | localPointToGlobal (Point< float > localPoint) const
| Converts a point relative to this component's top-left into a screen coordinate. More...
Rectangle< int > | localAreaToGlobal (Rectangle< int > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
Rectangle< float > | localAreaToGlobal (Rectangle< float > localArea) const
| Converts a rectangle from this component's coordinate space to a screen coordinate. More...
void | setTopLeftPosition (int x, int y)
| Moves the component to a new position. More...
void | setTopLeftPosition (Point< int > newTopLeftPosition)
| Moves the component to a new position. More...
void | setTopRightPosition (int x, int y)
| Moves the component to a new position. More...
void | setSize (int newWidth, int newHeight)
| Changes the size of the component. More...
void | setBounds (int x, int y, int width, int height)
| Changes the component's position and size. More...
void | setBounds (Rectangle< int > newBounds)
| Changes the component's position and size. More...
void | setBoundsRelative (float proportionalX, float proportionalY, float proportionalWidth, float proportionalHeight)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsRelative (Rectangle< float > proportionalArea)
| Changes the component's position and size in terms of fractions of its parent's size. More...
void | setBoundsInset (BorderSize< int > borders)
| Changes the component's position and size based on the amount of space to leave around it. More...
void | setBoundsToFit (Rectangle< int > targetArea, Justification justification, bool onlyReduceInSize)
| Positions the component within a given rectangle, keeping its proportions unchanged. More...
void | setCentrePosition (int x, int y)
| Changes the position of the component's centre. More...
void | setCentrePosition (Point< int > newCentrePosition)
| Changes the position of the component's centre. More...
void | setCentreRelative (float x, float y)
| Changes the position of the component's centre. More...
void | centreWithSize (int width, int height)
| Changes the component's size and centres it within its parent. More...
void | setTransform (const AffineTransform &transform)
| Sets a transform matrix to be applied to this component. More...
AffineTransform | getTransform () const
| Returns the transform that is currently being applied to this component. More...
bool | isTransformed () const noexcept
| Returns true if a non-identity transform is being applied to this component. More...
int | proportionOfWidth (float proportion) const noexcept
| Returns a proportion of the component's width. More...
int | proportionOfHeight (float proportion) const noexcept
| Returns a proportion of the component's height. More...
int | getParentWidth () const noexcept
| Returns the width of the component's parent. More...
int | getParentHeight () const noexcept
| Returns the height of the component's parent. More...
Rectangle< int > | getParentMonitorArea () const
| Returns the screen coordinates of the monitor that contains this component. More...
int | getNumChildComponents () const noexcept
| Returns the number of child components that this component contains. More...
Component * | getChildComponent (int index) const noexcept
| Returns one of this component's child components, by it index. More...
int | getIndexOfChildComponent (const Component *child) const noexcept
| Returns the index of this component in the list of child components. More...
const Array< Component * > & | getChildren () const noexcept
| Provides access to the underlying array of child components. More...
Component * | findChildWithID (StringRef componentID) const noexcept
| Looks for a child component with the specified ID. More...
void | addChildComponent (Component *child, int zOrder=-1)
| Adds a child component to this one. More...
void | addChildComponent (Component &child, int zOrder=-1)
| Adds a child component to this one. More...
void | addAndMakeVisible (Component *child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addAndMakeVisible (Component &child, int zOrder=-1)
| Adds a child component to this one, and also makes the child visible if it isn't already. More...
void | addChildAndSetID (Component *child, const String &componentID)
| Adds a child component to this one, makes it visible, and sets its component ID. More...
void | removeChildComponent (Component *childToRemove)
| Removes one of this component's child-components. More...
Component * | removeChildComponent (int childIndexToRemove)
| Removes one of this component's child-components by index. More...
void | removeAllChildren ()
| Removes all this component's children. More...
void | deleteAllChildren ()
| Removes and deletes all of this component's children. More...
Component * | getParentComponent () const noexcept
| Returns the component which this component is inside. More...
template<class TargetClass >
TargetClass * | findParentComponentOfClass () const
| Searches the parent components for a component of a specified class. More...
Component * | getTopLevelComponent () const noexcept
| Returns the highest-level component which contains this one or its parents. More...
bool | isParentOf (const Component *possibleChild) const noexcept
| Checks whether a component is anywhere inside this component or its children. More...
virtual void | parentHierarchyChanged ()
| Called to indicate that the component's parents have changed. More...
virtual void | childrenChanged ()
| Subclasses can use this callback to be told when children are added or removed, or when their z-order changes. More...
virtual bool | hitTest (int x, int y)
| Tests whether a given point is inside the component. More...
void | setInterceptsMouseClicks (bool allowClicksOnThisComponent, bool allowClicksOnChildComponents) noexcept
| Changes the default return value for the hitTest() method. More...
void | getInterceptsMouseClicks (bool &allowsClicksOnThisComponent, bool &allowsClicksOnChildComponents) const noexcept
| Retrieves the current state of the mouse-click interception flags. More...
bool | contains (Point< int > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | contains (Point< float > localPoint)
| Returns true if a given point lies within this component or one of its children. More...
bool | reallyContains (Point< int > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
bool | reallyContains (Point< float > localPoint, bool returnTrueIfWithinAChild)
| Returns true if a given point lies in this component, taking any overlapping siblings into account. More...
Component * | getComponentAt (int x, int y)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< int > position)
| Returns the component at a certain point within this one. More...
Component * | getComponentAt (Point< float > position)
| Returns the component at a certain point within this one. More...
void | repaint ()
| Marks the whole component as needing to be redrawn. More...
void | repaint (int x, int y, int width, int height)
| Marks a subsection of this component as needing to be redrawn. More...
void | repaint (Rectangle< int > area)
| Marks a subsection of this component as needing to be redrawn. More...
void | setBufferedToImage (bool shouldBeBuffered)
| Makes the component use an internal buffer to optimise its redrawing. More...
Image | createComponentSnapshot (Rectangle< int > areaToGrab, bool clipImageToComponentBounds=true, float scaleFactor=1.0f)
| Generates a snapshot of part of this component. More...
void | paintEntireComponent (Graphics &context, bool ignoreAlphaLevel)
| Draws this component and all its subcomponents onto the specified graphics context. More...
void | setPaintingIsUnclipped (bool shouldPaintWithoutClipping) noexcept
| This allows you to indicate that this component doesn't require its graphics context to be clipped when it is being painted. More...
bool | isPaintingUnclipped () const noexcept
| Returns true if this component doesn't require its graphics context to be clipped when it is being painted. More...
void | setComponentEffect (ImageEffectFilter *newEffect)
| Adds an effect filter to alter the component's appearance. More...
ImageEffectFilter * | getComponentEffect () const noexcept
| Returns the current component effect. More...
LookAndFeel & | getLookAndFeel () const noexcept
| Finds the appropriate look-and-feel to use for this component. More...
void | setLookAndFeel (LookAndFeel *newLookAndFeel)
| Sets the look and feel to use for this component. More...
virtual void | lookAndFeelChanged ()
| Called to let the component react to a change in the look-and-feel setting. More...
void | sendLookAndFeelChange ()
| Calls the lookAndFeelChanged() method in this component and all its children. More...
void | setOpaque (bool shouldBeOpaque)
| Indicates whether any parts of the component might be transparent. More...
bool | isOpaque () const noexcept
| Returns true if no parts of this component are transparent. More...
void | setBroughtToFrontOnMouseClick (bool shouldBeBroughtToFront) noexcept
| Indicates whether the component should be brought to the front when clicked. More...
bool | isBroughtToFrontOnMouseClick () const noexcept
| Indicates whether the component should be brought to the front when clicked-on. More...
void | setExplicitFocusOrder (int newFocusOrderIndex)
| Sets the focus order of this component. More...
int | getExplicitFocusOrder () const
| Returns the focus order of this component, if one has been specified. More...
void | setFocusContainerType (FocusContainerType containerType) noexcept
| Sets whether this component is a container for components that can have their focus traversed, and the type of focus traversal that it supports. More...
bool | isFocusContainer () const noexcept
| Returns true if this component has been marked as a focus container. More...
bool | isKeyboardFocusContainer () const noexcept
| Returns true if this component has been marked as a keyboard focus container. More...
Component * | findFocusContainer () const
| Returns the focus container for this component. More...
Component * | findKeyboardFocusContainer () const
| Returns the keyboard focus container for this component. More...
void | setWantsKeyboardFocus (bool wantsFocus) noexcept
| Sets a flag to indicate whether this component wants keyboard focus or not. More...
bool | getWantsKeyboardFocus () const noexcept
| Returns true if the component is interested in getting keyboard focus. More...
void | setMouseClickGrabsKeyboardFocus (bool shouldGrabFocus)
| Chooses whether a click on this component automatically grabs the focus. More...
bool | getMouseClickGrabsKeyboardFocus () const noexcept
| Returns the last value set with setMouseClickGrabsKeyboardFocus(). More...
void | grabKeyboardFocus ()
| Tries to give keyboard focus to this component. More...
void | giveAwayKeyboardFocus ()
| If this component or any of its children currently have the keyboard focus, this will defocus it, send a focus change notification, and try to pass the focus to the next component. More...
bool | hasKeyboardFocus (bool trueIfChildIsFocused) const
| Returns true if this component currently has the keyboard focus. More...
void | moveKeyboardFocusToSibling (bool moveToNext)
| Tries to move the keyboard focus to one of this component's siblings. More...
virtual std::unique_ptr< ComponentTraverser > | createFocusTraverser ()
| Creates a ComponentTraverser object to determine the logic by which focus should be passed from this component. More...
virtual std::unique_ptr< ComponentTraverser > | createKeyboardFocusTraverser ()
| Creates a ComponentTraverser object to use to determine the logic by which keyboard focus should be passed from this component. More...
void | setHasFocusOutline (bool hasFocusOutline) noexcept
| Use this to indicate that the component should have an outline drawn around it when it has keyboard focus. More...
bool | hasFocusOutline () const noexcept
| Returns true if this component should have a focus outline. More...
bool | isEnabled () const noexcept
| Returns true if the component (and all its parents) are enabled. More...
void | setEnabled (bool shouldBeEnabled)
| Enables or disables this component. More...
virtual void | enablementChanged ()
| Callback to indicate that this component has been enabled or disabled. More...
float | getAlpha () const noexcept
| Returns the component's current transparency level. More...
void | setAlpha (float newAlpha)
| Changes the transparency of this component. More...
virtual void | alphaChanged ()
| Called when setAlpha() is used to change the alpha value of this component. More...
void | setMouseCursor (const MouseCursor &cursorType)
| Changes the mouse cursor shape to use when the mouse is over this component. More...
virtual MouseCursor | getMouseCursor ()
| Returns the mouse cursor shape to use when the mouse is over this component. More...
void | updateMouseCursor () const
| Forces the current mouse cursor to be updated. More...
virtual void | paint (Graphics &g)
| Components can override this method to draw their content. More...
virtual void | paintOverChildren (Graphics &g)
| Components can override this method to draw over the top of their children. More...
void | mouseMove (const MouseEvent &event) override
| Called when the mouse moves inside a component. More...
void | mouseEnter (const MouseEvent &event) override
| Called when the mouse first enters a component. More...
void | mouseExit (const MouseEvent &event) override
| Called when the mouse moves out of a component. More...
void | mouseDown (const MouseEvent &event) override
| Called when a mouse button is pressed. More...
void | mouseDrag (const MouseEvent &event) override
| Called when the mouse is moved while a button is held down. More...
void | mouseUp (const MouseEvent &event) override
| Called when a mouse button is released. More...
void | mouseDoubleClick (const MouseEvent &event) override
| Called when a mouse button has been double-clicked on a component. More...
void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel) override
| Called when the mouse-wheel is moved. More...
void | mouseMagnify (const MouseEvent &event, float scaleFactor) override
| Called when a pinch-to-zoom mouse-gesture is used. More...
void | setRepaintsOnMouseActivity (bool shouldRepaint) noexcept
| Causes automatic repaints when the mouse enters or exits this component. More...
void | addMouseListener (MouseListener *newListener, bool wantsEventsForAllNestedChildComponents)
| Registers a listener to be told when mouse events occur in this component. More...
void | removeMouseListener (MouseListener *listenerToRemove)
| Deregisters a mouse listener. More...
void | addKeyListener (KeyListener *newListener)
| Adds a listener that wants to hear about keypresses that this component receives. More...
void | removeKeyListener (KeyListener *listenerToRemove)
| Removes a previously-registered key listener. More...
virtual bool | keyPressed (const KeyPress &key)
| Called when a key is pressed. More...
virtual bool | keyStateChanged (bool isKeyDown)
| Called when a key is pressed or released. More...
virtual void | modifierKeysChanged (const ModifierKeys &modifiers)
| Called when a modifier key is pressed or released. More...
virtual void | focusGained (FocusChangeType cause)
| Called to indicate that this component has just acquired the keyboard focus. More...
virtual void | focusLost (FocusChangeType cause)
| Called to indicate that this component has just lost the keyboard focus. More...
virtual void | focusOfChildComponentChanged (FocusChangeType cause)
| Called to indicate a change in whether or not this component is the parent of the currently-focused component. More...
bool | isMouseOver (bool includeChildren=false) const
| Returns true if the mouse is currently over this component. More...
bool | isMouseButtonDown (bool includeChildren=false) const
| Returns true if the mouse button is currently held down in this component. More...
bool | isMouseOverOrDragging (bool includeChildren=false) const
| True if the mouse is over this component, or if it's being dragged in this component. More...
Point< int > | getMouseXYRelative () const
| Returns the mouse's current position, relative to this component. More...
virtual void | resized ()
| Called when this component's size has been changed. More...
virtual void | moved ()
| Called when this component's position has been changed. More...
virtual void | childBoundsChanged (Component *child)
| Called when one of this component's children is moved or resized. More...
virtual void | parentSizeChanged ()
| Called when this component's immediate parent has been resized. More...
virtual void | broughtToFront ()
| Called when this component has been moved to the front of its siblings. More...
void | addComponentListener (ComponentListener *newListener)
| Adds a listener to be told about changes to the component hierarchy or position. More...
void | removeComponentListener (ComponentListener *listenerToRemove)
| Removes a component listener. More...
void | postCommandMessage (int commandId)
| Dispatches a numbered message to this component. More...
virtual void | handleCommandMessage (int commandId)
| Called to handle a command that was sent by postCommandMessage(). More...
int | runModalLoop ()
| Runs a component modally, waiting until the loop terminates. More...
void | enterModalState (bool takeKeyboardFocus=true, ModalComponentManager::Callback *callback=nullptr, bool deleteWhenDismissed=false)
| Puts the component into a modal state. More...
void | exitModalState (int returnValue)
| Ends a component's modal state. More...
bool | isCurrentlyModal (bool onlyConsiderForemostModalComponent=true) const noexcept
| Returns true if this component is the modal one. More...
bool | isCurrentlyBlockedByAnotherModalComponent () const
| Checks whether there's a modal component somewhere that's stopping this one from receiving messages. More...
virtual bool | canModalEventBeSentToComponent (const Component *targetComponent)
| When a component is modal, this callback allows it to choose which other components can still receive events. More...
virtual void | inputAttemptWhenModal ()
| Called when the user tries to click on a component that is blocked by another modal component. More...
NamedValueSet & | getProperties () noexcept
| Returns the set of properties that belong to this component. More...
const NamedValueSet & | getProperties () const noexcept
| Returns the set of properties that belong to this component. More...
Colour | findColour (int colourID, bool inheritFromParent=false) const
| Looks for a colour that has been registered with the given colour ID number. More...
void | setColour (int colourID, Colour newColour)
| Registers a colour to be used for a particular purpose. More...
void | removeColour (int colourID)
| If a colour has been set with setColour(), this will remove it. More...
bool | isColourSpecified (int colourID) const
| Returns true if the specified colour ID has been explicitly set for this component using the setColour() method. More...
void | copyAllExplicitColoursTo (Component &target) const
| This looks for any colours that have been specified for this component, and copies them to the specified target component. More...
virtual void | colourChanged ()
| This method is called when a colour is changed by the setColour() method. More...
void * | getWindowHandle () const
| Returns the underlying native window handle for this component. More...
Positioner * | getPositioner () const noexcept
| Returns the Positioner object that has been set for this component. More...
void | setPositioner (Positioner *newPositioner)
| Sets a new Positioner object for this component. More...
void | setCachedComponentImage (CachedComponentImage *newCachedImage)
| Gives the component a CachedComponentImage that should be used to buffer its painting. More...
CachedComponentImage * | getCachedComponentImage () const noexcept
| Returns the object that was set by setCachedComponentImage(). More...
void | setViewportIgnoreDragFlag (bool ignoreDrag) noexcept
| Sets a flag to indicate whether mouse drag events on this Component should be ignored when it is inside a Viewport with drag-to-scroll functionality enabled. More...
bool | getViewportIgnoreDragFlag () const noexcept
| Retrieves the current state of the Viewport drag-to-scroll functionality flag. More...
String | getTitle () const noexcept
| Returns the title text for this component. More...
void | setTitle (const String &newTitle)
| Sets the title for this component. More...
String | getDescription () const noexcept
| Returns the description for this component. More...
void | setDescription (const String &newDescription)
| Sets the description for this component. More...
String | getHelpText () const noexcept
| Returns the help text for this component. More...
void | setHelpText (const String &newHelpText)
| Sets the help text for this component. More...
void | setAccessible (bool shouldBeAccessible)
| Sets whether this component and its children are visible to accessibility clients. More...
bool | isAccessible () const noexcept
| Returns true if this component and its children are visible to accessibility clients. More...
AccessibilityHandler * | getAccessibilityHandler ()
| Returns the accessibility handler for this component, or nullptr if this component is not accessible. More...
void | invalidateAccessibilityHandler ()
| Invalidates the AccessibilityHandler that is currently being used for this component. More...
Public Member Functions inherited from MouseListener
virtual | ~MouseListener ()=default
| Destructor. More...
virtual void | mouseMove (const MouseEvent &event)
| Called when the mouse moves inside a component. More...
virtual void | mouseEnter (const MouseEvent &event)
| Called when the mouse first enters a component. More...
virtual void | mouseExit (const MouseEvent &event)
| Called when the mouse moves out of a component. More...
virtual void | mouseDown (const MouseEvent &event)
| Called when a mouse button is pressed. More...
virtual void | mouseDrag (const MouseEvent &event)
| Called when the mouse is moved while a button is held down. More...
virtual void | mouseUp (const MouseEvent &event)
| Called when a mouse button is released. More...
virtual void | mouseDoubleClick (const MouseEvent &event)
| Called when a mouse button has been double-clicked on a component. More...
virtual void | mouseWheelMove (const MouseEvent &event, const MouseWheelDetails &wheel)
| Called when the mouse-wheel is moved. More...
virtual void | mouseMagnify (const MouseEvent &event, float scaleFactor)
| Called when a pinch-to-zoom mouse-gesture is used. More...
Public Member Functions inherited from SettableTooltipClient
| ~SettableTooltipClient () override=default
| Destructor. More...
virtual void | setTooltip (const String &newTooltip)
| Assigns a new tooltip to this object. More...
String | getTooltip () override
| Returns the tooltip assigned to this object. More...
Public Member Functions inherited from TooltipClient
virtual | ~TooltipClient ()=default
| Destructor. More...
virtual String | getTooltip ()=0
| Returns the string that this object wants to show as its tooltip. More...
Public Member Functions inherited from Value::Listener
| Listener ()=default
virtual | ~Listener ()=default
virtual void | valueChanged (Value &value)=0
| Called when a Value object is changed. More...

## Public Attributes
std::function< void()> | onChange
| You can assign a lambda to this callback object to have it called when the selected ID is changed. More...

## Additional Inherited Members
Static Public Member Functions inherited from Component
static float JUCE_CALLTYPE | getApproximateScaleFactorForComponent (const Component *targetComponent)
| Returns the approximate scale factor for a given component by traversing its parent hierarchy and applying each transform and finally scaling this by the global scale factor. More...
static Component *JUCE_CALLTYPE | getCurrentlyFocusedComponent () noexcept
| Returns the component that currently has the keyboard focus. More...
static void JUCE_CALLTYPE | unfocusAllComponents ()
| If any component has keyboard focus, this will defocus it. More...
static void JUCE_CALLTYPE | beginDragAutoRepeat (int millisecondsBetweenCallbacks)
| Ensures that a non-stop stream of mouse-drag events will be sent during the current mouse-drag operation. More...
static bool JUCE_CALLTYPE | isMouseButtonDownAnywhere () noexcept
| Returns true if a mouse button is currently down. More...
static int JUCE_CALLTYPE | getNumCurrentlyModalComponents () noexcept
| Returns the number of components that are currently in a modal state. More...
static Component *JUCE_CALLTYPE | getCurrentlyModalComponent (int index=0) noexcept
| Returns one of the components that are currently modal. More...
Protected Member Functions inherited from SettableTooltipClient
| SettableTooltipClient ()=default

## Detailed Description

A component that lets the user choose from a drop-down list of choices.

The combo-box has a list of text strings, each with an associated id number, that will be shown in the drop-down list when the user clicks on the component.

The currently selected choice is displayed in the combo-box, and this can either be read-only text, or editable.

To find out when the user selects a different item or edits the text, you can assign a lambda to the onChange member, or register a ComboBox::Listener to receive callbacks.

## Member Enumeration Documentation

## ◆ ColourIds

enum ComboBox::ColourIds

A set of colour IDs to use to change the colour of various aspects of the combo box.

These constants can be used either via the Component::setColour(), or LookAndFeel::setColour() methods.

To change the colours of the menu that pops up, you can set the colour IDs in PopupMenu::ColourIDs.

See also
  Component::setColour, Component::findColour, LookAndFeel::setColour, LookAndFeel::findColour

Enumerator
backgroundColourId | The background colour to fill the box with.
textColourId | The colour for the text in the box.
outlineColourId | The colour for an outline around the box.
buttonColourId | The base colour for the button (a LookAndFeel class will probably use variations on this).
arrowColourId | The colour for the arrow shape that pops up the menu.
focusedOutlineColourId | The colour that will be used to draw a box around the edge of the component when it has focus.

## Constructor & Destructor Documentation

## ◆ ComboBox()

ComboBox::ComboBox | ( | const String & | componentName = `{}` | ) |
| explicit

Creates a combo-box.

On construction, the text field will be empty, so you should call the setSelectedId() or setText() method to choose the initial value before displaying it.

Parameters

  componentName | the name to set for the component (see Component::setName())

## ◆ ~ComboBox()

ComboBox::~ComboBox | ( |  | ) |
| override

Destructor.

## Member Function Documentation

## ◆ setEditableText()

void ComboBox::setEditableText | ( | bool | isEditable | ) |

Sets whether the text in the combo-box is editable.

The default state for a new ComboBox is non-editable, and can only be changed by choosing from the drop-down list.

## ◆ isTextEditable()

bool ComboBox::isTextEditable | ( |  | ) | const
| noexcept

Returns true if the text is directly editable.

See also
  setEditableText

## ◆ setJustificationType()

void ComboBox::setJustificationType | ( | Justification | justification | ) |

Sets the style of justification to be used for positioning the text.

The default is Justification::centredLeft. The text is displayed using a Label component inside the ComboBox.

## ◆ getJustificationType()

Justification ComboBox::getJustificationType | ( |  | ) | const
| noexcept

Returns the current justification for the text box.

See also
  setJustificationType

## ◆ addItem()

void ComboBox::addItem | ( | const String & | newItemText,
|  | int | newItemId
| ) |  |

Adds an item to be shown in the drop-down list.

Parameters

  newItemText | the text of the item to show in the list
  newItemId | an associated ID number that can be set or retrieved - see getSelectedId() and setSelectedId(). Note that this value can not be 0!

See also
  setItemEnabled, addSeparator, addSectionHeading, getNumItems, getItemText, getItemId

## ◆ addItemList()

void ComboBox::addItemList | ( | const StringArray & | items,
|  | int | firstItemIdOffset
| ) |  |

Adds an array of items to the drop-down list.

The item ID of each item will be its index in the StringArray + firstItemIdOffset.

## ◆ addSeparator()

void ComboBox::addSeparator | ( |  | ) |

Adds a separator line to the drop-down list.

This is like adding a separator to a popup menu. See PopupMenu::addSeparator().

## ◆ addSectionHeading()

void ComboBox::addSectionHeading | ( | const String & | headingName | ) |

Adds a heading to the drop-down list, so that you can group the items into different sections.

The headings are indented slightly differently to set them apart from the items on the list, and obviously can't be selected. You might want to add separators between your sections too.

See also
  addItem, addSeparator

## ◆ setItemEnabled()

void ComboBox::setItemEnabled | ( | int | itemId,
|  | bool | shouldBeEnabled
| ) |  |

This allows items in the drop-down list to be selectively disabled.

When you add an item, it's enabled by default, but you can call this method to change its status.

If you disable an item which is already selected, this won't change the current selection - it just stops the user choosing that item from the list.

## ◆ isItemEnabled()

bool ComboBox::isItemEnabled | ( | int | itemId | ) | const
| noexcept

Returns true if the given item is enabled.

## ◆ changeItemText()

void ComboBox::changeItemText | ( | int | itemId,
|  | const String & | newText
| ) |  |

Changes the text for an existing item.

## ◆ clear()

void ComboBox::clear | ( | NotificationType | notification = `sendNotificationAsync` | ) |

Removes all the items from the drop-down list.

If this call causes the content to be cleared, and a change-message will be broadcast according to the notification parameter.

See also
  addItem, getNumItems

## ◆ getNumItems()

int ComboBox::getNumItems | ( |  | ) | const
| noexcept

Returns the number of items that have been added to the list.

Note that this doesn't include headers or separators.

## ◆ getItemText()

String ComboBox::getItemText | ( | int | index | ) | const

Returns the text for one of the items in the list.

Note that this doesn't include headers or separators.

Parameters

  index | the item's index from 0 to (getNumItems() - 1)

## ◆ getItemId()

int ComboBox::getItemId | ( | int | index | ) | const
| noexcept

Returns the ID for one of the items in the list.

Note that this doesn't include headers or separators.

Parameters

  index | the item's index from 0 to (getNumItems() - 1)

## ◆ indexOfItemId()

int ComboBox::indexOfItemId | ( | int | itemId | ) | const
| noexcept

Returns the index in the list of a particular item ID.

If no such ID is found, this will return -1.

## ◆ getSelectedId()

int ComboBox::getSelectedId | ( |  | ) | const
| noexcept

Returns the ID of the item that's currently shown in the box.

If no item is selected, or if the text is editable and the user has entered something which isn't one of the items in the list, then this will return 0.

See also
  setSelectedId, getSelectedItemIndex, getText

## ◆ getSelectedIdAsValue()

Value & ComboBox::getSelectedIdAsValue | ( |  | ) |

Returns a Value object that can be used to get or set the selected item's ID.

You can call Value::referTo() on this object to make the combo box control another Value object.

## ◆ setSelectedId()

void ComboBox::setSelectedId | ( | int | newItemId,
|  | NotificationType | notification = `sendNotificationAsync`
| ) |  |

Sets one of the items to be the current selection.

This will set the ComboBox's text to that of the item that matches this ID.

Parameters

  newItemId | the new item to select
  notification | determines the type of change notification that will be sent to listeners if the value changes

See also
  getSelectedId, setSelectedItemIndex, setText

## ◆ getSelectedItemIndex()

int ComboBox::getSelectedItemIndex | ( |  | ) | const

Returns the index of the item that's currently shown in the box.

If no item is selected, or if the text is editable and the user has entered something which isn't one of the items in the list, then this will return -1.

See also
  setSelectedItemIndex, getSelectedId, getText

## ◆ setSelectedItemIndex()

void ComboBox::setSelectedItemIndex | ( | int | newItemIndex,
|  | NotificationType | notification = `sendNotificationAsync`
| ) |  |

Sets one of the items to be the current selection.

This will set the ComboBox's text to that of the item at the given index in the list.

Parameters

  newItemIndex | the new item to select
  notification | determines the type of change notification that will be sent to listeners if the value changes

See also
  getSelectedItemIndex, setSelectedId, setText

## ◆ getText()

String ComboBox::getText | ( |  | ) | const

Returns the text that is currently shown in the combo-box's text field.

If the ComboBox has editable text, then this text may have been edited by the user; otherwise it will be one of the items from the list, or possibly an empty string if nothing was selected.

See also
  setText, getSelectedId, getSelectedItemIndex

## ◆ setText()

void ComboBox::setText | ( | const String & | newText,
|  | NotificationType | notification = `sendNotificationAsync`
| ) |  |

Sets the contents of the combo-box's text field.

The text passed-in will be set as the current text regardless of whether it is one of the items in the list. If the current text isn't one of the items, then getSelectedId() will return 0, otherwise it will return the appropriate ID.

Parameters

  newText | the text to select
  notification | determines the type of change notification that will be sent to listeners if the text changes

See also
  getText

## ◆ showEditor()

void ComboBox::showEditor | ( |  | ) |

Programmatically opens the text editor to allow the user to edit the current item.

This is the same effect as when the box is clicked-on.

See also
  Label::showEditor();

## ◆ showPopup()

virtual void ComboBox::showPopup | ( |  | ) |
| virtual

Pops up the combo box's list.

This is virtual so that you can override it with your own custom popup mechanism if you need some really unusual behaviour.

## ◆ hidePopup()

void ComboBox::hidePopup | ( |  | ) |

Hides the combo box's popup list, if it's currently visible.

## ◆ isPopupActive()

bool ComboBox::isPopupActive | ( |  | ) | const
| noexcept

Returns true if the popup menu is currently being shown.

## ◆ getRootMenu() [1/2]

PopupMenu * ComboBox::getRootMenu | ( |  | ) |
| noexcept

Returns the PopupMenu object associated with the ComboBox.

Can be useful for adding sub-menus to the ComboBox standard PopupMenu

## ◆ getRootMenu() [2/2]

const PopupMenu * ComboBox::getRootMenu | ( |  | ) | const
| noexcept

Returns the PopupMenu object associated with the ComboBox.

## ◆ addListener()

void ComboBox::addListener | ( | Listener * | listener | ) |

Registers a listener that will be called when the box's content changes.

## ◆ removeListener()

void ComboBox::removeListener | ( | Listener * | listener | ) |

Deregisters a previously-registered listener.

## ◆ setTextWhenNothingSelected()

void ComboBox::setTextWhenNothingSelected | ( | const String & | newMessage | ) |

Sets a message to display when there is no item currently selected.

See also
  getTextWhenNothingSelected

## ◆ getTextWhenNothingSelected()

String ComboBox::getTextWhenNothingSelected | ( |  | ) | const

Returns the text that is shown when no item is selected.

See also
  setTextWhenNothingSelected

## ◆ setTextWhenNoChoicesAvailable()

void ComboBox::setTextWhenNoChoicesAvailable | ( | const String & | newMessage | ) |

Sets the message to show when there are no items in the list, and the user clicks on the drop-down box.

By default it just says "no choices", but this lets you change it to something more meaningful.

## ◆ getTextWhenNoChoicesAvailable()

String ComboBox::getTextWhenNoChoicesAvailable | ( |  | ) | const

Returns the text shown when no items have been added to the list.

See also
  setTextWhenNoChoicesAvailable

## ◆ setTooltip()

void ComboBox::setTooltip | ( | const String & | newTooltip | ) |
| overridevirtual

Gives the ComboBox a tooltip.

Reimplemented from SettableTooltipClient.

## ◆ setScrollWheelEnabled()

void ComboBox::setScrollWheelEnabled | ( | bool | enabled | ) |
| noexcept

This can be used to allow the scroll-wheel to nudge the chosen item.

By default it's disabled, and I'd recommend leaving it disabled if there's any chance that the control might be inside a scrollable list or viewport.

## ◆ enablementChanged()

void ComboBox::enablementChanged | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ colourChanged()

void ComboBox::colourChanged | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ focusGained()

void ComboBox::focusGained | ( | Component::FocusChangeType |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ focusLost()

void ComboBox::focusLost | ( | Component::FocusChangeType |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ handleAsyncUpdate()

void ComboBox::handleAsyncUpdate | ( |  | ) |
| overridevirtual

Implements AsyncUpdater.

## ◆ getTooltip()

String ComboBox::getTooltip | ( |  | ) |
| overridevirtual

Reimplemented from SettableTooltipClient.

References label.

## ◆ mouseDown()

void ComboBox::mouseDown | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseDrag()

void ComboBox::mouseDrag | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseUp()

void ComboBox::mouseUp | ( | const MouseEvent & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ mouseWheelMove()

void ComboBox::mouseWheelMove | ( | const MouseEvent & | ,
|  | const MouseWheelDetails & |
| ) |  |
| overridevirtual

Reimplemented from Component.

## ◆ lookAndFeelChanged()

void ComboBox::lookAndFeelChanged | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ paint()

void ComboBox::paint | ( | Graphics & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ resized()

void ComboBox::resized | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ keyStateChanged()

bool ComboBox::keyStateChanged | ( | bool |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ keyPressed()

bool ComboBox::keyPressed | ( | const KeyPress & |  | ) |
| overridevirtual

Reimplemented from Component.

## ◆ valueChanged()

void ComboBox::valueChanged | ( | Value & |  | ) |
| overridevirtual

Implements Value::Listener.

## ◆ parentHierarchyChanged()

void ComboBox::parentHierarchyChanged | ( |  | ) |
| overridevirtual

Reimplemented from Component.

## Member Data Documentation

## ◆ onChange

std::function<void()> ComboBox::onChange

You can assign a lambda to this callback object to have it called when the selected ID is changed.

The documentation for this class was generated from the following file:

- juce_ComboBox.h